- try downloading clearsigned InRelease before trying Release.gpg
[ntk/apt.git] / test / integration / test-bug-595691-empty-and-broken-archive-files
1 #!/bin/sh
2 set -e
3
4 TESTDIR=$(readlink -f $(dirname $0))
5 . $TESTDIR/framework
6 setupenvironment
7 configarchitecture "i386"
8
9 buildaptarchive
10 touch aptarchive/Packages
11 setupflataptarchive
12
13 testaptgetupdate() {
14 rm -rf rootdir/var/lib/apt rootdir/var/cache/apt
15 aptget update 2>> testaptgetupdate.diff >> testaptgetupdate.diff || true
16 sed -i -e '/^Fetched / d' -e 's#\[[0-9]* [kMGTPY]*B\]#\[\]#' testaptgetupdate.diff
17 GIVEN="$1"
18 shift
19 msgtest "Test for correctness of" "apt-get update with $*"
20 if [ -z "$GIVEN" ]; then
21 echo -n "" | checkdiff - testaptgetupdate.diff && msgpass || msgfail
22 else
23 echo "$GIVEN" | checkdiff - testaptgetupdate.diff && msgpass || msgfail
24 fi
25 rm testaptgetupdate.diff
26 }
27
28 createemptyarchive() {
29 find aptarchive/ \( -name "Packages*" -o -name "en*" \) -type f -delete
30 if [ "en" = "$1" ]; then
31 echo -n "" | $COMPRESSOR > aptarchive/Packages.$COMPRESS
32 fi
33 touch aptarchive/Packages
34 echo -n "" | $COMPRESSOR > aptarchive/${1}.$COMPRESS
35 aptftparchive release aptarchive/ > aptarchive/Release
36 signreleasefiles
37 rm -f aptarchive/Packages
38 }
39
40 createemptyfile() {
41 find aptarchive/ \( -name "Packages*" -o -name "en*" \) -type f -delete
42 if [ "en" = "$1" ]; then
43 echo -n "" | $COMPRESSOR > aptarchive/Packages.$COMPRESS
44 fi
45 touch aptarchive/Packages aptarchive/${1}.$COMPRESS
46 aptftparchive release aptarchive/ > aptarchive/Release
47 signreleasefiles
48 rm -f aptarchive/Packages
49 }
50
51 setupcompressor() {
52 COMPRESSOR="$1"
53 case $COMPRESSOR in
54 gzip) COMPRESS="gz";;
55 bzip2) COMPRESS="bz2";;
56 lzma) COMPRESS="lzma";;
57 esac
58 echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; };
59 Dir::Bin::gzip \"/does/not/exist\";
60 Dir::Bin::bzip2 \"/does/not/exist\";
61 Dir::Bin::lzma \"/does/not/exist\";" > rootdir/etc/apt/apt.conf.d/00compressor
62 if [ -e "/bin/${COMPRESSOR}" ]; then
63 echo "Dir::Bin::${COMPRESSOR} \"/bin/${COMPRESSOR}\";" >> rootdir/etc/apt/apt.conf.d/00compressor
64 elif [ -e "/usr/bin/${COMPRESSOR}" ]; then
65 echo "Dir::Bin::${COMPRESSOR} \"/usr/bin/${COMPRESSOR}\";" >> rootdir/etc/apt/apt.conf.d/00compressor
66 else
67 msgtest "Test for availability of compressor" "${COMPRESSOR}"
68 msgfail
69 exit 1
70 fi
71 }
72
73 testoverfile() {
74 setupcompressor "$1"
75
76 createemptyfile 'en'
77 testaptgetupdate "Get:1 file: InRelease []
78 Ign file:$(readlink -f aptarchive)/ Translation-en
79 Reading package lists..." "empty file en.$COMPRESS over file"
80
81 createemptyarchive 'en'
82 testaptgetupdate "Get:1 file: InRelease []
83 Reading package lists..." "empty archive en.$COMPRESS over file"
84
85 createemptyarchive 'Packages'
86 # FIXME: Why omits the file transport the Packages Get line?
87 #Get:3 file: Packages []
88 testaptgetupdate "Ign file:$(readlink -f aptarchive)/ Translation-en
89 Get:1 file: InRelease []
90 Reading package lists..." "empty archive Packages.$COMPRESS over file"
91
92 createemptyfile 'Packages'
93 testaptgetupdate "Ign file:$(readlink -f aptarchive)/ Translation-en
94 Get:1 file: InRelease []
95 Err file: Packages
96 Undetermined Error
97 W: Failed to fetch file:$(readlink -f aptarchive/Packages.$COMPRESS) Undetermined Error
98
99 E: Some index files failed to download, they have been ignored, or old ones used instead." "empty file Packages.$COMPRESS over file"
100 }
101
102 testoverhttp() {
103 setupcompressor "$1"
104
105 createemptyfile 'en'
106 testaptgetupdate "Get:1 http://localhost InRelease []
107 Get:2 http://localhost/ Translation-en
108 Get:3 http://localhost Packages []
109 Ign http://localhost/ Translation-en
110 Reading package lists..." "empty file en.$COMPRESS over http"
111
112 createemptyarchive 'en'
113 testaptgetupdate "Get:1 http://localhost InRelease []
114 Get:2 http://localhost/ Translation-en []
115 Get:3 http://localhost Packages []
116 Reading package lists..." "empty archive en.$COMPRESS over http"
117
118 createemptyarchive 'Packages'
119 testaptgetupdate "Get:1 http://localhost InRelease []
120 Ign http://localhost/ Translation-en
121 Get:2 http://localhost Packages []
122 Reading package lists..." "empty archive Packages.$COMPRESS over http"
123
124 createemptyfile 'Packages'
125 #FIXME: we should response with a good error message instead
126 testaptgetupdate "Get:1 http://localhost InRelease []
127 Ign http://localhost/ Translation-en
128 Get:2 http://localhost Packages
129 Err http://localhost Packages
130 Undetermined Error
131 W: Failed to fetch http://localhost:8080/Packages.$COMPRESS Undetermined Error
132
133 E: Some index files failed to download, they have been ignored, or old ones used instead." "empty file Packages.$COMPRESS over http"
134 }
135
136 for COMPRESSOR in 'gzip' 'bzip2' 'lzma'; do testoverfile $COMPRESSOR; done
137
138 # do the same again with http instead of file
139 changetowebserver
140
141 for COMPRESSOR in 'gzip' 'bzip2' 'lzma'; do testoverhttp $COMPRESSOR; done